Package org.apache.tomcat.jni

# Class Global

java.lang.Object
org.apache.tomcat.jni.Global

@Deprecated public class Global extends Object
Deprecated.
The scope of the APR/Native Library will be reduced in Tomcat 9.1.x / Tomcat Native 2.x and has been reduced in Tomcat 10.1.x / Tomcat Native 2.x onwards to only include those components required to provide OpenSSL integration with the NIO and NIO2 connectors.
Global

Author:
  Mladen Turk

## Constructor Summary

Constructors
Constructor
Description
`Global()`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`static long`
`childInit(String fname, long pool)`
Deprecated.
Re-open a mutex in a child process.
`static long`
`create(String fname, int mech, long pool)`
Deprecated.
Create and initialize a mutex that can be used to synchronize both processes and threads.
`static int`
`destroy(long mutex)`
Deprecated.
Destroy the mutex and free the memory associated with the lock.
`static int`
`lock(long mutex)`
Deprecated.
Acquire the lock for the given mutex.
`static int`
`trylock(long mutex)`
Deprecated.
Attempt to acquire the lock for the given mutex.
`static int`
`unlock(long mutex)`
Deprecated.
Release the lock for the given mutex.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Global

public Global()
Deprecated.

## Method Details

### create

public static long create(String fname, int mech, long pool) throws Error
Deprecated.
Create and initialize a mutex that can be used to synchronize both processes and threads. Note: There is considerable overhead in using this API if only cross-process or cross-thread mutual exclusion is required. See apr_proc_mutex.h and apr_thread_mutex.h for more specialized lock routines.
Warning : Check APR_HAS_foo_SERIALIZE defines to see if the platform supports APR_LOCK_foo. Only APR_LOCK_DEFAULT is portable.

Parameters:
  `fname` - A file name to use if the lock mechanism requires one. This argument should always be provided. The lock code itself will determine if it should be used.
  `mech` - The mechanism to use for the interprocess lock, if any; one of

                  APR_LOCK_FCNTL
                  APR_LOCK_FLOCK
                  APR_LOCK_SYSVSEM
                  APR_LOCK_POSIXSEM
                  APR_LOCK_PROC_PTHREAD
                  APR_LOCK_DEFAULT     pick the default mechanism for the platform

  `pool` - the pool from which to allocate the mutex.
Returns:
  Newly created mutex.
Throws:
  `Error` - If an error occurred

### childInit

public static long childInit(String fname, long pool) throws Error
Deprecated.
Re-open a mutex in a child process.

Parameters:
  `fname` - A file name to use if the mutex mechanism requires one. This argument should always be provided. The mutex code itself will determine if it should be used. This filename should be the same one that was passed to apr_proc_mutex_create().
  `pool` - The pool to operate on. This function must be called to maintain portability, even if the underlying lock mechanism does not require it.
Returns:
  Newly opened mutex.
Throws:
  `Error` - If an error occurred

### lock

public static int lock(long mutex)
Deprecated.
Acquire the lock for the given mutex. If the mutex is already locked, the current thread will be put to sleep until the lock becomes available.

Parameters:
  `mutex` - the mutex on which to acquire the lock.
Returns:
  the operation status

### trylock

public static int trylock(long mutex)
Deprecated.
Attempt to acquire the lock for the given mutex. If the mutex has already been acquired, the call returns immediately with APR_EBUSY. Note: it is important that the APR_STATUS_IS_EBUSY(s) macro be used to determine if the return value was APR_EBUSY, for portability reasons.

Parameters:
  `mutex` - the mutex on which to attempt the lock acquiring.
Returns:
  the operation status

### unlock

public static int unlock(long mutex)
Deprecated.
Release the lock for the given mutex.

Parameters:
  `mutex` - the mutex from which to release the lock.
Returns:
  the operation status

### destroy

public static int destroy(long mutex)
Deprecated.
Destroy the mutex and free the memory associated with the lock.

Parameters:
  `mutex` - the mutex to destroy.
Returns:
  the operation status